Package org.gradle.plugins.signing

# Class Signature

java.lang.Object
org.gradle.api.internal.artifacts.publish.AbstractPublishArtifact
org.gradle.plugins.signing.Signature

All Implemented Interfaces:
  `PublishArtifact`, `Buildable`, `org.gradle.api.internal.artifacts.PublishArtifactInternal`

public class Signature extends org.gradle.api.internal.artifacts.publish.AbstractPublishArtifact
A digital signature file artifact.

A signature file is always generated from another file, which may be a `PublishArtifact`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `Signature.Generator`
  Configuration-cache compatible signature generator.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Signature(Closure<File> toSign, Closure<String> classifier, SignatureSpec signatureSpec, Object... tasks)`
  Creates a signature artifact for the file returned by the `toSign` closure.
  `Signature(File toSign, String classifier, SignatureSpec signatureSpec, Object... tasks)`
  Creates a signature artifact for the given file, with the given classifier.
  `Signature(File toSign, SignatureSpec signatureSpec, Object... tasks)`
  Creates a signature artifact for the given file.
  `Signature(Callable<File> toSign, Callable<String> classifier, SignatureSpec signatureSpec, Object... tasks)`
  Creates a signature artifact for the file returned by the `toSign` closure.
  `Signature(PublishArtifact toSign, SignatureSpec signatureSpec, Object... tasks)`
  Creates a signature artifact for the given public artifact.
  `Signature(Buildable source, Callable<File> toSign, Callable<String> classifier, Callable<String> name, SignatureSpec signatureSpec, Object... tasks)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `generate()`
  Generates the signature file.
  `TaskDependency`
  `getBuildDependencies()`
  Returns a dependency which contains the tasks which build this artifact.
  `String`
  `getClassifier()`
  The classifier of the signature artifact.
  `Date`
  `getDate()`
  The date of the signature artifact.
  `String`
  `getExtension()`
  The extension of the signature artifact.
  `File`
  `getFile()`
  The file for the generated signature, which may not yet exist.
  `(package private) @Nullable Signature.Generator`
  `getGenerator()`
  `String`
  `getName()`
  The name of the signature artifact.
  `Signatory`
  `getSignatory()`
  The signatory of this signature file.
  `SignatureSpec`
  `getSignatureSpec()`
  `SignatureType`
  `getSignatureType()`
  The file representation type of the signature.
  `(package private) Buildable`
  `getSource()`
  `File`
  `getToSign()`
  The file that is to be signed.
  `String`
  `getType()`
  The type of the signature artifact.
  `void`
  `setClassifier(String classifier)`
  `void`
  `setDate(Date date)`
  `void`
  `setExtension(String extension)`
  `void`
  `setName(String name)`
  `void`
  `setSignatureSpec(SignatureSpec signatureSpec)`
  `void`
  `setType(String type)`
  `boolean`
  `shouldBePublished()`

  ### Methods inherited from class org.gradle.api.internal.artifacts.publish.AbstractPublishArtifact

  `builtBy, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Signature

    public Signature(PublishArtifact toSign, SignatureSpec signatureSpec, Object... tasks)
    Creates a signature artifact for the given public artifact.

    The file to sign will be the file of the given artifact and the classifier of this signature artifact will default to the classifier of the given artifact to sign.

    The artifact to sign may change after being used as the source for this signature.

    Parameters:
      `toSign` - The artifact that is to be signed
      `signatureSpec` - The specification of how the artifact is to be signed
      `tasks` - The task(s) that will invoke `generate()` on this signature (optional)

  - ### Signature

    Signature(Buildable source, Callable<File> toSign, Callable<String> classifier, Callable<String> name, SignatureSpec signatureSpec, Object... tasks)

  - ### Signature

    public Signature(File toSign, SignatureSpec signatureSpec, Object... tasks)
    Creates a signature artifact for the given file.
    Parameters:
      `toSign` - The file that is to be signed
      `signatureSpec` - The specification of how the artifact is to be signed
      `tasks` - The task(s) that will invoke `generate()` on this signature (optional)

  - ### Signature

    public Signature(File toSign, String classifier, SignatureSpec signatureSpec, Object... tasks)
    Creates a signature artifact for the given file, with the given classifier.
    Parameters:
      `toSign` - The file that is to be signed
      `classifier` - The classifier to assign to the signature (should match the files)
      `signatureSpec` - The specification of how the artifact is to be signed
      `tasks` - The task(s) that will invoke `generate()` on this signature (optional)

  - ### Signature

    public Signature(Closure<File> toSign, Closure<String> classifier, SignatureSpec signatureSpec, Object... tasks)
    Creates a signature artifact for the file returned by the `toSign` closure.

    The closures will be "evaluated" on demand whenever the value is needed (e.g. at generation time)

    Parameters:
      `toSign` - A closure that produces a File for the object to sign (non File return values will be used as the path to the file)
      `classifier` - A closure that produces the classifier to assign to the signature artifact on demand
      `signatureSpec` - The specification of how the artifact is to be signed
      `tasks` - The task(s) that will invoke `generate()` on this signature (optional)

  - ### Signature

    public Signature(Callable<File> toSign, Callable<String> classifier, SignatureSpec signatureSpec, Object... tasks)
    Creates a signature artifact for the file returned by the `toSign` closure.

    The closures will be "evaluated" on demand whenever the value is needed (e.g. at generation time)

    Parameters:
      `toSign` - A closure that produces a File for the object to sign (non File return values will be used as the path to the file)
      `classifier` - A closure that produces the classifier to assign to the signature artifact on demand
      `signatureSpec` - The specification of how the artifact is to be signed
      `tasks` - The task(s) that will invoke `generate()` on this signature (optional)

- ## Method Details

  - ### getToSign

    @PathSensitive(NONE) @InputFile public File getToSign()
    The file that is to be signed.
    Returns:
      The file. May be `null` if unknown at this time.

  - ### setName

    public void setName(String name)

  - ### getName

    @Internal public String getName()
    The name of the signature artifact.

    Defaults to the name of the signature `file`.

    Returns:
      The name. May be `null` if unknown at this time. FIXME Nullability consistency with superclass.

  - ### setExtension

    public void setExtension(String extension)

  - ### getExtension

    @Internal public String getExtension()
    The extension of the signature artifact.

    Defaults to the specified file extension of the `signature type`.

    Returns:
      The extension. May be `null` if unknown at this time. FIXME Nullability consistency with superclass.

  - ### setType

    public void setType(String type)

  - ### getType

    @Internal public String getType()
    The type of the signature artifact.

    Defaults to the extension of the `file to sign` plus the extension of the `signature type`. For example, when signing the file ‘my.zip’ with a signature type with extension ‘sig’, the default type is ‘zip.sig’.

    Returns:
      The type. May be `null` if the file to sign or signature type are unknown at this time. FIXME Nullability consistency with superclass.

  - ### setClassifier

    public void setClassifier(String classifier)

  - ### getClassifier

    @Internal public String getClassifier()
    The classifier of the signature artifact.

    Defaults to the classifier of the source artifact (if signing an artifact) or the given classifier at construction (if given).

    Returns:
      The classifier. May be `null` if unknown at this time.

  - ### setDate

    public void setDate(Date date)

  - ### getDate

    @Internal public Date getDate()
    The date of the signature artifact.

    Defaults to the last modified time of the `signature file` (if exists)

    Returns:
      The date of the signature. May be `null` if unknown at this time.

  - ### getFile

    @OutputFile public File getFile()
    The file for the generated signature, which may not yet exist.

    The file will be placed alongside the `file to sign` with the extension of the `signature type`.

    Returns:
      The signature file. May be `null` if unknown at this time.
    See Also:
      - `FIXME Nullability consistency with superclass.`

  - ### getSignatory

    @Internal("already tracked as part of the Sign task") public Signatory getSignatory()
    The signatory of this signature file.
    Returns:
      The signatory. May be `null` if unknown at this time.

  - ### getSignatureType

    @Internal("already tracked as part of the Sign task") public SignatureType getSignatureType()
    The file representation type of the signature.
    Returns:
      The signature type. May be `null` if unknown at this time.

  - ### setSignatureSpec

    public void setSignatureSpec(SignatureSpec signatureSpec)

  - ### getSignatureSpec

    @Internal public SignatureSpec getSignatureSpec()

  - ### getSource

    @Internal Buildable getSource()

  - ### getBuildDependencies

    @Internal public TaskDependency getBuildDependencies()
    Description copied from interface: `Buildable`
    Returns a dependency which contains the tasks which build this artifact. All `Buildable` implementations must ensure that the returned dependency object is live, so that it tracks changes to the dependencies of this buildable.
    Specified by:
      `getBuildDependencies` in interface `Buildable`
    Overrides:
      `getBuildDependencies` in class `org.gradle.api.internal.artifacts.publish.AbstractPublishArtifact`
    Returns:
      The dependency. Never returns null. Returns an empty dependency when this artifact is not built by any tasks.

  - ### shouldBePublished

    public boolean shouldBePublished()

  - ### generate

    public void generate()
    Generates the signature file.

    In order to generate the signature, the `file to sign`, `signatory` and `signature type` must be known (i.e. non `null`).

    Throws:
      `InvalidUserDataException` - if the there is insufficient information available to generate the signature.

  - ### getGenerator

    @Nullable Signature.Generator getGenerator()